#include "config.h"
#include <fstream>
#include <iostream>
#include <cctype>
#include <cstdlib>
using namespace std;

string				Config::configFile;
map<string, string>	Config::configMap;

int Config::readNumber(const string __name)
{
	return atoi(configMap[__name].c_str());
}

const string Config::readString(const string __name)
{
	return configMap[__name];
}

void Config::parse(const string __filename)
{
	ifstream in(__filename.c_str());
	if(!in.good()){
		cerr << "failed to read config file: " << __filename << endl;
		_exit(1);
	}
	
	/* ServerPort = 80 */
	enum{
		ParsingName,
		ParsingValue,
		ParsingComment,
		ParsingString
	}state = ParsingName;
	string name, value;
	for(; !in.eof();){
		char ch = in.get();
		switch(state){
		case ParsingName:
			if(ch == ' ' || ch == '\t')
				break;
			else if(ch == '\r' || ch == '\n')
				name.clear();
			else if(ch == '=')
				state = ParsingValue;
			else if(ch == '#')
				state = ParsingComment;
			else
				name.push_back(ch);
			break;
		case ParsingValue:
			if(ch == '"' && value.empty())
				state = ParsingString;
			else if(ch == ' ' || ch == '\t')
				break;
			else if(ch == '\r' || ch == '\n'){
				if(!name.empty())
					configMap[name] = value;
				name.clear();
				value.clear();
				state = ParsingName;
			}else if(ch == '#')
				state = ParsingComment;
			else
				value.push_back(ch);
			break;
		case ParsingString:
			if(ch == '"')
				state = ParsingValue;
			else
				value.push_back(ch);
			break;
		case ParsingComment:
			if(ch == '\r' || ch == '\n')
				state = ParsingName;
			break;
		}
	}
	
	if(!name.empty())
		configMap[name] = value;
}

