#include "filelog.h"
#include "config.h"
#include <cstring>
#include <fcntl.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <cstdio>

static int 		dbg_term = 0, dbg_file = 0, log_day = 0;
static void 	init_file_path();
static char		dir[256] = {0}, logToTerminal = 1;
static string	fileName;
static FILE* 	fp_log = NULL;


static int createDirectory(char* __dir) 
{
	/* 091009 from myqq */
	char *p, *path = __dir;
	if( access( path, 0 ) == 0 )
		return 0;
	for( p=path; *p; p++ ) {
		if( p>path && *p == '/' ) {
			*p = 0;
			if( access( path, 0 ) != 0 ) {
#ifdef __WIN32__
				mkdir( path );
#else
				if( mkdir( path, S_IRWXU ) != 0 )
					return -1;
#endif
			}
			*p = '/';
		}
	}
#ifdef __WIN32__
	return mkdir( path );
#else
	return mkdir( path, S_IRWXU );
#endif
}

void init_file_path() 
{
	char tmp[64];
	time_t t = time( NULL );
	struct tm* tm1 = localtime(&t);
	if( !tm1 ) {
		perror("log.c init_file_path: ERROR GETTING SYSTEM TIME.");
	}
	log_day = tm1->tm_mday;
	strftime( tmp, 64, "/%Y-%m-%d.txt", tm1 );
	if(dir[0] == 0)
		strncpy(dir, Config::readString("LogDirectory").c_str(), 255);

	if(dir[0] == 0)
		return;
		
	if(Config::readString("LogToTerminal") == "False")
		logToTerminal = 0;
	else
		logToTerminal = 1;

	if(createDirectory(dir) < 0)
		return ;

	fileName = string(dir) + tmp;
	if( fp_log )
		fclose( fp_log );
	fp_log = fopen( fileName.c_str(), "w" );
}


void FileLog::writeLine(const string __log) 
{
	time_t t = time( NULL );
	struct tm* tm1 = localtime(&t);
	if( !tm1 ) return;
	if( tm1->tm_mday != log_day )
		init_file_path();

	char tmp[16];
	strftime( tmp, 15, "%X", tm1 );
	fprintf( fp_log, "[%s]%s\r\n", tmp, __log.c_str());
	if(logToTerminal)
		printf("[%s]%s\n", tmp, __log.c_str());
	fflush( fp_log );
}
