#ifndef HTTPCONNECTION_H
#define HTTPCONNECTION_H

#include "cppthread.h" // Base class: CppThread
#include "httpsocket.h"
#include "httprequest.h"
#include "httpresponse.h"
#include "httpshrimp.h"
#include "contentbuffer.h"
#include <ctime>

class HttpConnection : public CppThread {
private:
	vector<HttpShrimp*>	shrimps;
	vector<ContentBuffer*>	buffers;
	int					minBlockSize;
	int					maxBlockSize;
	int					blockSize;
	bool				speeded;
	time_t				startTime;
	unsigned int		contentLength;
	unsigned int		currentPosition;
	
	HttpSocket*			clientSocket;
	HttpSocket*			remoteSocket;
	HttpRequest*		request;
	HttpResponse*		response;
	
	bool				closed;
	
	
	bool				transferTrunkedData();
	bool				transferData();
	bool				transferDataSpeeded();
	bool				isSpeedable();
public:
	/* Shrimp is our friend! */
	friend class		HttpShrimp;
	
	HttpConnection(HttpSocket* __sock);
	~HttpConnection();
	void				process();
	void				doCONNECT();
	bool				isClosed()const;
	void				close();
	
	HttpRequest*		getRequest();
	HttpResponse*		getResponse();
	
	void				updateBlockSize(int __size);
};

#endif // HTTPCONNECTION_H
