#ifndef HTTPSHRIMP_H
#define HTTPSHRIMP_H

#include "cppthread.h" // Base class: CppThread
#include "httpsocket.h"
#include "contentbuffer.h"

class HttpConnection;
class HttpRequest;
class HttpResponse;
class HttpShrimp : public CppThread {
private:
	int						shrimpId;
	HttpConnection*			connection;
	HttpRequest*			request;
	HttpResponse*			response;
	HttpSocket*				remoteSocket;
	ContentBuffer*			contentBuffer;
	
	bool					dead;
	bool					sentHeader;
	
	bool					establishConnection(ContentBuffer* __cb);
	
	unsigned int			startTime;
	unsigned int			transferedBytes;
	
	unsigned int			calculateSpeed();
	void					fork();
public:
	HttpShrimp(HttpConnection* __conn, ContentBuffer* __cb);
	~HttpShrimp();

	void					process();
	void					kill();
	int						getShrimpId();
};

#endif // HTTPSHRIMP_H
